// Auto-generated. Do not edit!

// (in-package rc_common_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let KeyValue = require('./KeyValue.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class CameraParam {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.is_color_camera = null;
      this.exposure_time = null;
      this.gain = null;
      this.noise = null;
      this.line_status_all = null;
      this.line_source = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('is_color_camera')) {
        this.is_color_camera = initObj.is_color_camera
      }
      else {
        this.is_color_camera = false;
      }
      if (initObj.hasOwnProperty('exposure_time')) {
        this.exposure_time = initObj.exposure_time
      }
      else {
        this.exposure_time = 0.0;
      }
      if (initObj.hasOwnProperty('gain')) {
        this.gain = initObj.gain
      }
      else {
        this.gain = 0.0;
      }
      if (initObj.hasOwnProperty('noise')) {
        this.noise = initObj.noise
      }
      else {
        this.noise = 0.0;
      }
      if (initObj.hasOwnProperty('line_status_all')) {
        this.line_status_all = initObj.line_status_all
      }
      else {
        this.line_status_all = 0;
      }
      if (initObj.hasOwnProperty('line_source')) {
        this.line_source = initObj.line_source
      }
      else {
        this.line_source = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type CameraParam
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [is_color_camera]
    bufferOffset = _serializer.bool(obj.is_color_camera, buffer, bufferOffset);
    // Serialize message field [exposure_time]
    bufferOffset = _serializer.float32(obj.exposure_time, buffer, bufferOffset);
    // Serialize message field [gain]
    bufferOffset = _serializer.float32(obj.gain, buffer, bufferOffset);
    // Serialize message field [noise]
    bufferOffset = _serializer.float32(obj.noise, buffer, bufferOffset);
    // Serialize message field [line_status_all]
    bufferOffset = _serializer.uint32(obj.line_status_all, buffer, bufferOffset);
    // Serialize message field [line_source]
    // Serialize the length for message field [line_source]
    bufferOffset = _serializer.uint32(obj.line_source.length, buffer, bufferOffset);
    obj.line_source.forEach((val) => {
      bufferOffset = KeyValue.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type CameraParam
    let len;
    let data = new CameraParam(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [is_color_camera]
    data.is_color_camera = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [exposure_time]
    data.exposure_time = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [gain]
    data.gain = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [noise]
    data.noise = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [line_status_all]
    data.line_status_all = _deserializer.uint32(buffer, bufferOffset);
    // Deserialize message field [line_source]
    // Deserialize array length for message field [line_source]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.line_source = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.line_source[i] = KeyValue.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    object.line_source.forEach((val) => {
      length += KeyValue.getMessageSize(val);
    });
    return length + 21;
  }

  static datatype() {
    // Returns string type for a message object
    return 'rc_common_msgs/CameraParam';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '2eb9ee0acad4e9760c1077c5f46c6b50';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Camera parameters that relate to a published image
    
    # Header with timestamp and frame_id to which the parameters belong
    Header header
    
    # True in case of a color camera
    bool is_color_camera
    
    # Exposure time of the camera in seconds
    float32 exposure_time
    
    # Gain factor in dB
    float32 gain
    
    # Standard deviation of the expected noise in pixel intensity
    # at full image resolution
    float32 noise
    
    # Line status for DigitalIO control according to GenICam SFNC:
    # Current status of all available line signals in a single bitfield
    uint32 line_status_all
    
    # Line sources for DigitalIO control according to GenICam SFNC:
    # Specifies for each line which internal acquisition or I/O source
    # signal is output on the respective line.
    #
    # The keys define the lines, the values define the sources; e.g.
    # [ {key: "out1", value: "ExposureActive"},
    #   {key: "out2", value: "Low"},
    #   ...
    # ]
    #
    KeyValue[] line_source
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: rc_common_msgs/KeyValue
    string key
    string value
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new CameraParam(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.is_color_camera !== undefined) {
      resolved.is_color_camera = msg.is_color_camera;
    }
    else {
      resolved.is_color_camera = false
    }

    if (msg.exposure_time !== undefined) {
      resolved.exposure_time = msg.exposure_time;
    }
    else {
      resolved.exposure_time = 0.0
    }

    if (msg.gain !== undefined) {
      resolved.gain = msg.gain;
    }
    else {
      resolved.gain = 0.0
    }

    if (msg.noise !== undefined) {
      resolved.noise = msg.noise;
    }
    else {
      resolved.noise = 0.0
    }

    if (msg.line_status_all !== undefined) {
      resolved.line_status_all = msg.line_status_all;
    }
    else {
      resolved.line_status_all = 0
    }

    if (msg.line_source !== undefined) {
      resolved.line_source = new Array(msg.line_source.length);
      for (let i = 0; i < resolved.line_source.length; ++i) {
        resolved.line_source[i] = KeyValue.Resolve(msg.line_source[i]);
      }
    }
    else {
      resolved.line_source = []
    }

    return resolved;
    }
};

module.exports = CameraParam;
